// ScreenMode.cpp

// what : DirectX gȂAvP[VpAEBhẼtXN[؂ւNXB
// who  : LaLa Moo-Moo (ITAGAKI Takahiro) mailto:t_itagaki@sannet.ne.jp
// when : 2002/05/01

#include "stdafx.h"
#include "ScreenMode.h"

ScreenMode::ScreenMode(UINT width, UINT height, UINT minbpp, UINT menuID, UINT notifyMessage)
	: WIDTH(width), HEIGHT(height), MINBPP(minbpp),
	  FIRST_MENU(menuID), LAST_MENU(menuID + 100), MENU_WINDOWED(menuID + 0), MENU_FULLSCREEN(menuID + 1), MENU_CUSTOM(menuID + 2),
	  NOTIFY_MESSAGE(notifyMessage)
{
	m_hWnd = NULL;
	m_hMenu = m_hModeMenu = NULL;
	m_IsWindowed = FALSE;
}
BOOL	ScreenMode::ChangeMode(const DEVMODE* mode)
{
	if(mode)
	{	// tXN[
		if(mode != &m_DefaultMode)
		{	// ftHg[hŌɎw肳ꂽ[h
			memcpy(&m_DefaultMode, mode, sizeof(DEVMODE));
			m_DefaultMode.dmFields = DM_BITSPERPEL | DM_PELSHEIGHT | DM_PELSWIDTH | DM_DISPLAYFREQUENCY;
		}
		if(IsWindowed())
		{	// EBhE[h˃tXN[[h
			ShowWindow(m_hWnd, SW_SHOWNORMAL);
			SaveWindowState(m_hWnd);
			// ʃ[h̕ύX
			if(ChangeDisplaySettings(&m_DefaultMode, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
				return FALSE;
			// j[̏AX^C̕ύXAő剻
			SaveMenu();
			SetWindowPos(m_hWnd, NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);	// xBĂłȂƕ\B
			SetWindowLong(m_hWnd, GWL_STYLE, GetWindowLong(m_hWnd, GWL_STYLE) & ~(WS_CAPTION | WS_BORDER | WS_THICKFRAME));
			SetWindowLong(m_hWnd, GWL_EXSTYLE, GetWindowLong(m_hWnd, GWL_EXSTYLE) & ~(WS_EX_CLIENTEDGE | WS_EX_WINDOWEDGE));
			SetWindowPos(m_hWnd, HWND_TOPMOST, 0, 0, mode->dmPelsWidth, mode->dmPelsHeight, SWP_SHOWWINDOW);
			m_IsWindowed = FALSE;
		}
		else if(mode != &m_DefaultMode)
		{	// tXN[[hˑ̃tXN[[h
			if(ChangeDisplaySettings(&m_DefaultMode, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
				return FALSE;
		}
		else
		{	// ύX̕KvȂ
			return TRUE;
		}
		// j[XV
		TCHAR text[1024];
		wsprintf(text, MENU_FULLSCREEN_TEXT, m_DefaultMode.dmPelsWidth, m_DefaultMode.dmPelsHeight, m_DefaultMode.dmBitsPerPel, m_DefaultMode.dmDisplayFrequency);
		ModifyMenu(m_hModeMenu, MENU_FULLSCREEN, MF_STRING, MENU_FULLSCREEN, text);
		CheckMenuItem(m_hModeMenu, MENU_WINDOWED, MF_UNCHECKED);
		CheckMenuItem(m_hModeMenu, MENU_FULLSCREEN, MF_CHECKED);
		// [hύXꂽƂʒm
		if(NOTIFY_MESSAGE != 0)
			PostMessage(m_hWnd, NOTIFY_MESSAGE, (WPARAM)FALSE, (LPARAM)&m_DefaultMode);
		RedrawWindow(m_hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
		return TRUE;
	}
	else if(IsFullScreen())
	{	// EBhE
		// j[XV
		CheckMenuItem(m_hModeMenu, MENU_WINDOWED, MF_CHECKED);
		CheckMenuItem(m_hModeMenu, MENU_FULLSCREEN, MF_UNCHECKED);
		// j[AX^CAʒu̕
		RestoreMenu();
		ChangeDisplaySettings(NULL, 0);
		SetWindowPos(m_hWnd, NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);	// xBĂłȂƕ\B
		RestoreWindowState();
		m_IsWindowed = TRUE;
		// [hύXꂽƂʒm
		if(NOTIFY_MESSAGE != 0)
			PostMessage(m_hWnd, NOTIFY_MESSAGE, (WPARAM)TRUE, (LPARAM)NULL);
		RedrawWindow(m_hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
		return TRUE;
	}
	// ύX̕KvȂ
	return TRUE;
}
BOOL	ScreenMode::OnMessage(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam, LRESULT& lResult)
{
	switch(msg)
	{
	case WM_CREATE:
	{
		m_IsWindowed = TRUE;
		SaveWindowState(hWnd);
		// ftHgtXN[̐FAtbV[g݂͌̂̂g
		m_DefaultMode.dmSize = sizeof(DEVMODE);
		EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &m_DefaultMode);
		m_DefaultMode.dmPelsWidth  = WIDTH;
		m_DefaultMode.dmPelsHeight = HEIGHT;
		// p\ȃOtBbN[h񋓂
		DEVMODE dm;
		dm.dmSize = sizeof(DEVMODE);
		m_ModeList.clear();
		for(int i = 0; EnumDisplaySettings(NULL, i, &dm); i++)
		{
			if(dm.dmPelsWidth == WIDTH && dm.dmPelsHeight == HEIGHT && dm.dmBitsPerPel >= MINBPP)
				m_ModeList.push_back(dm);
		}
		// j[̍쐬
		UINT id = FIRST_MENU;
		TCHAR text[1024];
		m_hModeMenu = CreateMenu();
		// EBhE\
		AppendMenu(m_hModeMenu, MF_STRING, id++, MENU_WINDOWED_TEXT);
		// ftHgSʕ\
		wsprintf(text, MENU_FULLSCREEN_TEXT, m_DefaultMode.dmPelsWidth, m_DefaultMode.dmPelsHeight, m_DefaultMode.dmBitsPerPel, m_DefaultMode.dmDisplayFrequency);
		AppendMenu(m_hModeMenu, MF_STRING, id++, text);
		// ̑̑Sʕ\[h
		HMENU hOtherMode = CreateMenu();
		for(ModeList::const_iterator mode = m_ModeList.begin(); mode != m_ModeList.end(); ++mode)
		{
			wsprintf(text, MENU_CUSTOMMODE_TEXT, mode->dmBitsPerPel, mode->dmDisplayFrequency);
			AppendMenu(hOtherMode, MF_STRING, id++, text);
		}
		AppendMenu(m_hModeMenu, MF_POPUP, (UINT)hOtherMode, MENU_OTHERMODE_TEXT);
		// `FbN
		CheckMenuItem(m_hModeMenu, MENU_WINDOWED, IsWindowed() ? MF_CHECKED : MF_UNCHECKED);
		CheckMenuItem(m_hModeMenu, MENU_FULLSCREEN, IsFullScreen() ? MF_CHECKED : MF_UNCHECKED);
		return TRUE;
	}
	case WM_DESTROY:
		if(IsFullScreen())
		{	// ɖ߂Ă
			ChangeDisplaySettings(NULL, 0);
		}
		if(IsMenu(m_hMenu))
			DestroyMenu(m_hMenu);
		if(IsMenu(m_hModeMenu))
			DestroyMenu(m_hModeMenu);
		return TRUE;
	case WM_ACTIVATEAPP:
		if(wParam == 0)
			ChangeMode(NULL);
		return TRUE;
	case WM_SYSCOMMAND:
		switch(wParam & 0xFFF0)
		{
		case SC_MAXIMIZE:
			ChangeMode(&m_DefaultMode);
			lResult = 0;
			return FALSE;
		default:
			return TRUE;
		}
	case WM_MOUSEMOVE:
		if(IsFullScreen() && wParam == 0)
		{
			int y = (int)(short)HIWORD(lParam);
			if(y == 0 && m_hMenu != NULL)
				RestoreMenu();
			else if(y > 0 && m_hMenu == NULL)
				SaveMenu();
		}
		return TRUE;
	case WM_EXITMENULOOP:
		if(!(BOOL/*IsTrackPopupMenu*/)wParam && IsFullScreen())
		{	// tXN[[hAj[IяIƃj[
			SaveMenu();
		}
		return TRUE;
	case WM_COMMAND:
	{
		UINT cmd = LOWORD(wParam);
		if(cmd == MENU_WINDOWED)
		{	// EBhE
			ChangeMode(NULL);
		}
		else if(cmd == MENU_FULLSCREEN)
		{	// ftHgtXN[
			ChangeMode(&m_DefaultMode);
		}
		else if(FIRST_MENU <= cmd && cmd <= LAST_MENU)
		{	// JX^tXN[
			UINT index = cmd - MENU_CUSTOM;
			if(index < m_ModeList.size())
				ChangeMode(&m_ModeList[index]);
		}
		else
			return TRUE;
		return FALSE;
	}
	default:
		return TRUE;
	}
}
void	ScreenMode::SaveWindowState(HWND hWnd)
{
	m_hWnd = hWnd;
	GetWindowRect(m_hWnd, &m_WndRect);
	m_WndStyle   = GetWindowLong(m_hWnd, GWL_STYLE);
	m_WndExStyle = GetWindowLong(m_hWnd, GWL_EXSTYLE);
}
void	ScreenMode::RestoreWindowState()
{
	SetWindowLong(m_hWnd, GWL_STYLE, m_WndStyle);
	SetWindowLong(m_hWnd, GWL_EXSTYLE, m_WndExStyle);
	SetWindowPos(m_hWnd, HWND_NOTOPMOST, m_WndRect.left, m_WndRect.top, m_WndRect.right - m_WndRect.left, m_WndRect.bottom - m_WndRect.top, SWP_SHOWWINDOW);
}
void	ScreenMode::SaveMenu()
{
	m_hMenu = GetMenu(m_hWnd);
	SetMenu(m_hWnd, NULL);
}
void	ScreenMode::RestoreMenu()
{
	SetMenu(m_hWnd, m_hMenu);
	m_hMenu = NULL;
}

